%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Node_list = Shell_Node_Branch(Elm_list, Node_ID, Quad_RBE2_Stiffen_Strategy)

global DB_ELEMENTS;
global AT_ELEMENTS;

global ErrCode;

Elm_list = unique(intersect(Elm_list, Get_Elements_From_Nodes(Node_ID, [])));

Node_list = zeros(100,1);
counter = 0;

for i=1:size(Elm_list,1)
    
    switch DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.N_nodes
        
        case {3,6}
            
            [member_flag, location] = ismember(Node_ID, DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1:3)); %#ok<ASGLU>
            
            switch location
                
                case 1
                    counter = counter + 1;
                    Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);
                    
                    counter = counter + 1;
                    Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);
                    
                case 2
                    counter = counter + 1;
                    Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);
                    
                    counter = counter + 1;
                    Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);
                    
                case 3
                    counter = counter + 1;
                    Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);
                    
                    counter = counter + 1;
                    Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);
                    
            end
            
        case {4,8}
            
            [member_flag, location] = ismember(Node_ID, DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1:4)); %#ok<ASGLU>
            
            switch Quad_RBE2_Stiffen_Strategy
                
                case 'EDGE'
                    
                    switch location

                        case 1
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(4);

                        case 2
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);

                        case 3
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(4);

                        case 4
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);

                    end
                    
                case 'DIAGONAL'
                    
                    switch location

                        case 1
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);

                        case 2
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(4);

                        case 3
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);

                        case 4
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);

                    end
                    
                case 'ALL_DIR'
                    
                    switch location
                    
                        case 1
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);
                            
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(4);

                        case 2
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);
                            
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(4);

                        case 3
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);
                            
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(4);

                        case 4
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(1);

                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(2);
                            
                            counter = counter + 1;
                            Node_list(counter) = DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.Nodes(3);

                    end
                    
                otherwise
                    
                    fprintf (1, '\nОшибка функции Shell_Node_Branch: недопустимое значение параметра Quad_RBE2_Stiffen_Strategy [%s] !\n', Quad_RBE2_Stiffen_Strategy);
                    ErrCode = -1;
                    return;
                    
            end
        
    end
    
end

Node_list = Node_list(1:counter);
Node_list = unique(Node_list);
